#include <stdio.h>

#define BASE_ADR 0x40000000
#define BITBAND_BASE_ADR 0x42000000
/*
#define PORT_BASE_ADR 0x40010800
#define PORT_OFFSET 0x0400
#define REGISTER_OFFSET_IDR 0x08
#define REGISTER_OFFSET_ODR 0x0C
*/

#define PORT_BASE_ADR 0x40020000
#define PORT_OFFSET 0x0400
#define REGISTER_OFFSET_IDR 0x10
#define REGISTER_OFFSET_ODR 0x14

#define NUMBER_OF_PORTS 5
#define NUMBER_OF_BITS 16

long adress;
char letter[8]={'A','B','C','D','E','F','G','H'};
int port, bit;

FILE *file;

int main(int argc, char *argv[]){
    
 printf("Bit-bang generator for STM32 ARM controller\n");   
  
 file = fopen ("out.h", "wt"); 
    
 for(port = 0; port < NUMBER_OF_PORTS; ++port){

  fprintf(file, "\n\n//PORT");
  fputc(letter[port], file);

  for(bit = 0; bit < NUMBER_OF_BITS; ++bit){
 
    adress = BITBAND_BASE_ADR + (PORT_BASE_ADR + port*PORT_OFFSET + REGISTER_OFFSET_IDR - BASE_ADR)*0x20 + bit*4;      
          
    fprintf(file, "\n#define PIN");
    fputc(letter[port], file);
    fprintf(file, "_%d   (*((volatile unsigned long *) 0x%8X ))",bit,adress);          
  }
  
  for(bit = 0; bit < NUMBER_OF_BITS; ++bit){
    
    adress = BITBAND_BASE_ADR + (PORT_BASE_ADR + port*PORT_OFFSET + REGISTER_OFFSET_ODR - BASE_ADR)*0x20 + bit*4;      
          
    fprintf(file, "\n#define PORT");
    fputc(letter[port], file);
    fprintf(file, "_%d   (*((volatile unsigned long *) 0x%8X ))",bit,adress);          
  }
  
  
 }   
  
 fclose(file);   
    
 getchar();   
 return 0;
}
